* Utilities for making info tables	v0.00   1987 J.R.Oakley  QJUMP
*
        section prog
*
        include 'dev8_keys_qdos_sms'
        include 'dev8_keys_err'
        include 'dev8_mac_assert'
        include 'dev8_keys_wwork'
        include 'dev8_keys_wman'
        include 'dev1_asm_qptr_keys'
        include 'dev8_keys_qdos_pt'
*
        xref    bem_sri6
        xref    bem_glin
        xref    bem_sia1
        xref    bem_csar
        xref    bem_cfar
        xref    bem_gars
        xref    bem_relv
        xref    bem_sfv1
*
        xdef    bem_glng
        xdef    bem_gptr
        xdef    bem_gipt
        xdef    bem_giob
*
*       Set up to read long words from an f.p. array
*
*       Registers:
*	      Entry		        Exit
*       D0			        error code
*       D1			        number of entries (smashable)
*       D2			        increment
*       D7      expected number of entries      preserved
*       A0			        first element
*       A3      NT entry for array	        preserved
*
bem_sfa1
        cmp.b   #3,0(a6,a3.l) 	; is it an array? 
        beq.s   bem_sfar		; yes, don't allow for variable then
        cmp.w   #1,d7		; just one element expected?
        bne.s   bem_sfar		; no, set floating point array
        jsr     bem_sfv1(pc)		; yes, get variable/expression
        bne.s   bem_exer		; whoops
        move.w  d3,d1		; copy item count
        bra.s   bem_exok
bem_sfar
        jsr     bem_cfar(pc)		; check we have an f.p. array
        bne.s   bem_exer		; ...oops
        move.w  6(a6,a0.l),d1 	; size
        addq.w  #1,d1
        cmp.w   d7,d1		; must be the same as before
        bne.s   bem_exbp		; ...oops
        cmp.w   #1,4(a6,a0.l) 	; must be one-dimensional
        bne.s   bem_exbp
*
        move.w  8(a6,a0.l),d2 	; get index multiplier
        move.l  0(a6,a0.l),a0 	; point to first element
        add.l   bv_vvbas(a6),a0
        mulu    #6,d2		; elements are six bytes each
bem_exok
        moveq   #0,d0
bem_exer
        rts
bem_exbp
        moveq   #err.ipar,d0
        rts
*
*       Get a set of long words from an f.p. array, and fill them in in the
*       definition.
*
*       Registers:
*	      Entry		        Exit
*       D0-D3			        smashed
*       D6      definition entry size	        preserved
*       D7      number of entries	        preserved
*       A0			        smashed
*       A3      array entry in name table       preserved
*       A4      first definition entry	        smashed
*
bem_glng
        jsr     bem_sri6(pc)		; ensure there's RI stack space
        bsr     bem_sfa1		; set up for 1-d f.p. array
        bne     bem_exer		; ...oops
        bra.s   bem_gwde
bem_gwdl
        jsr     bem_glin(pc)		; convert f.p. element to long word
        move.l  d3,(a4)		; fill it in
        add.w   d6,a4		; next object
bem_gwde
        dbra    d1,bem_gwdl
        moveq   #0,d0
bem_exp6
        addq.l  #6,bv_rip(a6)
        tst.l   d0
        rts
*
*       Get a set of long words from an f.p. array, and fill them in in the
*       definition as relative pointers.
*
*       Registers:
*	      Entry		        Exit
*       D0-D3			        smashed
*       D6      definition entry size	        preserved
*       D7      number of entries	        preserved
*       A0			        smashed
*       A3      array entry in name table       preserved
*       A4      first definition entry	        smashed
*
bem_gptr
        jsr     bem_sri6(pc)		; ensure there's RI stack space
        bsr     bem_sfa1		; set up for 1-d f.p. array
        bne     bem_exer		; ...oops
        bra.s   bem_gpte
bem_gptl
        jsr     bem_glin(pc)		; convert f.p. element to long word
        move.l  d3,(a4)		; and fill it in
        add.w   d6,a4		; next object
bem_gpte
        dbra    d1,bem_gptl
        bra     bem_exp6
*
*       Put pointers to information object tables into information
*       window definitions, and accumulate total number of objects
*
*       Registers:
*	      Entry		        Exit
*       D0-D3			        smashed
*       D4			        number of objects in table
*       D6      definition entry size	        preserved
*       D7      number of entries	        preserved
*       A0			        smashed
*       A1/A2			        smashed
*       A3      array entry in name table       preserved
*       A4      first definition entry	        smashed
*
bem_gipt
        jsr     bem_sri6(pc)		; ensure there's RI stack space
        bsr     bem_sfa1		; set up for 1-d f.p. array
        bne     bem_exer		; ...oops
        moveq   #0,d4
        bra.s   bem_gipe
bem_gipl
        jsr     bem_glin(pc)		; convert f.p. element to long word
        move.l  d3,a2		; object table is here
        tst.l   d3			; is there an object table?
        beq.s   bem_setp		; no, just set pointer
        addq.l  #mol_numo,a2		; skip heap header
        add.w   (a2)+,d4		; accumulate number of objects
bem_setp
        move.l  a2,(a4)		; and fill it in
        add.w   d6,a4		; next object
bem_gipe
        dbra    d1,bem_gipl
        bra     bem_exp6
*
*       Fill in object type, object pointer, and convert combined pointer
*       to relative for patterns or blobs.
*
*       Fill in object type, object pointer, and convert combined pointer
*       to relative for patterns or blobs.
*
stk_pstr equ    $00
stk_ptr  equ    $00
stk_lstr equ    $04
stk_max  equ    $04
stk_istr equ    $06
stk_inc  equ    $06
stk_pspr equ    $08
stk_lspr equ    $0c
stk_ispr equ    $0e
stk_pblb equ    $10
stk_lblb equ    $14
stk_iblb equ    $16
stk_ppat equ    $18
stk_lpat equ    $1c
stk_ipat equ    $1e
stk.fram equ    $20
*
bem_giob
        jsr     bem_sri6(pc)		; ensure there's space for fp number
        sub.w   #stk.fram,a7		; make space for running pointers
        jsr     bem_gars(pc)		; get array starts
        bne.s   beo_exit		; ...oops
*
*       Fill in type, item number, pointer to object, and action routine code
*
*       D3      item counter
*       D5      type array increment
*       A3      pointer to type array
*
        bra.s   beo_fobe
beo_fobl
        move.b  1(a6,a3.l),d0 	; object type
        ble.s   beo_ul		; (underlined) text
        and.w   #6,d0		; object type even only
        move.b  d0,(a4)		; fill it in
        add.w   d0,d0
        add.w   d0,d0
        bra.s   beo_nele
beo_ul
        asr.b   #1,d0
        move.b  d0,(a4)		; text type
        moveq   #0,d0		; text list
beo_nele
        move.l  stk_ptr(a7,d0.w),d1	; get pointer to next element
        beq.s   beo_exbp		; can't have one of that type
        move.w  stk_max(a7,d0.w),d2	; number left
        bmi.s   beo_exor		; none, bother
        subq.w  #1,d2
        move.w  d2,stk_max(a7,d0.w)	; number left now
        assert  text,0
        tst.w   d0			; is this a string?
        bne.s   beo_cvfp		; no, convert fp pointer
*
        move.l  d1,a0
        add.w   stk_inc(a7),a0	; point to next string
        move.l  a0,stk_ptr(a7)	; and save result
        move.l  d1,a0		; point to string in VV area
        jsr     bem_relv(pc)		; copy it into the user heap
        bne.s   beo_exit		 ; clang
        move.l  a1,wwo_pobj-wwo_type(a4) ; fill in pointer
        bra.s   beo_pnxt		 ; and do next object
*
cvreg   reg     d0/d3
beo_cvfp
        move.w  stk_inc(a7,d0.w),d2	; get array increment
        movem.l cvreg,-(sp)
        move.l  d1,a0		; point to next array element
        move.l  bv_rip(a6),a1 	; and RI stack
        jsr     bem_glin(pc)		; convert to a long integer
        move.l  d3,a1		; keep answer
        movem.l (sp)+,cvreg
*
        bne.s   beo_exbp		 ; ...oops
        move.l  a0,stk_ptr(a7,d0.w)	 ; next element is here
        move.l  a1,wwo_pobj-wwo_type(a4) ; fill in pointer
*
beo_pnxt
        add.w   d5,a3		; next type byte
        add.w   d6,a4		; next object
beo_fobe
        dbra    d3,beo_fobl
        moveq   #0,d0
beo_exit
        add.w   #stk.fram,sp
        bra     bem_exp6
beo_exbp
        moveq   #err.ipar,d0
        bra.s   beo_exit
beo_exor
        moveq   #err.orng,d0
        bra.s   beo_exit
*
        end
