* Some utilities			v0.00   Sept 1987	J.R.Oakley  QJUMP
*
        section prog
*
        include 'dev1_asm_qptr_keys'
        include 'dev8_keys_qdos_pt'
        include 'dev8_keys_qdos_io'
        include 'dev8_keys_qdos_sms'
        include 'dev8_keys_err'
*
        xref    ut_getch
*
        xdef    ber_mode
*
        xdef    be_rmode
        xdef    be_sprsp
        xdef    be_rpixl
*
*       Read the display mode
*
*       result=RMODE    result may be 1, 2, 4 or 8
*
ber_mode
        moveq   #-1,d1		; read mode...
        moveq   #-1,d2		; ...and (smashed) display
        moveq   #sms.dmod,d0
        trap    #1
        rts
*
be_rmode
        bsr     ber_mode		; read mode
        move.w  d1,d4		; is it mode 4?
        bne.s   ber_push		; nope
        moveq   #4,d4
ber_push
        moveq   #2,d1		; need space for an integer
        move.w  bv.chrix,a2
        jsr     (a2)
ber_retp
        move.l  bv_rip(a6),a1 	; get the stack pointer
        subq.l  #2,a1		; wind back an integers worth
ber_reti
        move.l  a1,bv_rip(a6)
        move.w  d4,0(a6,a1.l) 	; shove on the answer
        moveq   #3,d4		; 'tis an integer
        moveq   #0,d0		; no problem
ber_exit
        rts
ber_exbp
        moveq   #err.ipar,d0
        bra.s   ber_exit
*
*       Calculate space required for a sprite
*
be_sprsp
        move.w  ca.gtint,a2		; get some integers
        jsr     (a2)
        bne     ber_exit		; bonk
        subq.w  #2,d3		; exactly two
        bne     ber_exbp		; bonk bonk
*
        moveq   #15,d4
        add.w   0(a6,a1.l),d4 	; x size...
        and.w   #$fff0,d4		; ...rounded up to nearest 16
        lsr.w   #1,d4		; 16 pixels take 8 bytes
        mulu    2(a6,a1.l),d4 	; multiply by number of lines
        add.w   #24,d4		; there's a 24-byte overhead, too
        addq.l  #2,a1		; knock off one integer
        bra     ber_reti		; and change the other and return it
*
*       Read pixel colour or scan for colour
*
*       result=RPIXL([#ch,]xstart,ystart[,dirn[,colour[,same]]])
*
*       If no direction is given then the result is the colour of the pixel
*       at xstart,ystart.
*
*       If no colour or colour -1 is given then the scan looks for a pixel of 
*       different colour to the start pixel.
*       If a positive colour is given then the scan looks for a pixel of
*       a different colour to that given.
*       If the same flag is set to 1 then the scan looks for a pixel
*       of the given colour/same colour as the start pixel.
*
*       If scanning then the result is the new co-ordinate if susccessful,
*       or -1 if the edge of the window was met before the scan finished.
*
be_rpixl
        jsr     ut_getch(pc)		; get a channel ID
        bne     ber_exit		; ...oops
        move.w  ca.gtint,a2
        jsr     (a2)		; get integer parameters
        bne     ber_exit
        subq.w  #2,d3		; at least two
        bmi.s   ber_exbp
*
        move.l  0(a6,a1.l),d1 	; get start point
        addq.l  #4,a1		; and skip 
        moveq   #0,d2		; assume straight read
*
        subq.w  #1,d3		; more parameters?
        bmi.s   ber_rpix		; no, read
        move.w  0(a6,a1.l),d2 	; yes, get direction
        addq.l  #2,a1
        and.w   #3,d2		; must be 0..3
        add.w   d2,d2
        or.w    #$8000,d2		; set scan flag
        swap    d2			; this goes to upper word
*
        subq.w  #1,d3		; more parameters?
        bmi.s   ber_rpix		; no
        move.w  0(a6,a1.l),d2 	; yes, colour to find
        addq.l  #2,a1
        bmi.s   ber_nocl		; negative colour, not really given
        bset    #iop..gcl,d2		; flag colour given
ber_nocl
*
        subq.w  #1,d3
        bmi.s   ber_rpix
        tst.w   0(a6,a1.l)		; is same flag to be set?
        addq.l  #2,a1
        beq.s   ber_diff		; no
        bset    #iop..ssc,d2		; yes, set it
ber_diff
        tst.w   d3
        bne     ber_exbp		; still parameters left, bomb
*
ber_rpix
        move.l  a1,bv_rip(a6) 	; point to TOS
        moveq   #-1,d3		; sometime
        move.l  a4,a0		; in this channel
        moveq   #iop.rpxl,d0
        trap    #3			; read the pixel
        tst.l   d0
        bne     ber_exit		; boing
        move.l  d1,d4		; here's the answer
        tst.l   d2			; scan?
        bpl     ber_retp		; no, return colour
        swap    d4
        bra     ber_retp		; yes, return co-ordinate
*
        end
